// -----------------------------------------------------------------
//
// PlaneFilterExample
//
// 'One day free toy'
// Created by Andrew Tsiantis
//
// If all the points of a surface belong to 
// the infinite plane with the equation
// 
// PlaneFilter_A*x+PlaneFilter_B*y+PlaneFilter_C*z+PlaneFilter_D=0
//
// within a margin 'PlaneFilter_margin' 
// then the surface is added 
// to the PlaneFilter_Result[] array
//
// -----------------------------------------------------------------

Include "PlaneFilter.geo";

SetFactory("OpenCASCADE");
Box(1) = {0, 0, 0, 1, 1, 1};
Cylinder(2) = {0, 0.5, 0.5, 1, 0, 0, 0.2, 2*Pi};
Vol[]=BooleanDifference{ Volume{1}; Delete; }{ Volume{2}; Delete; };

AllSurfaces[]= Surface "*";

PlaneFilter_A=0;
PlaneFilter_B=0;
PlaneFilter_C=1;
PlaneFilter_D=-1;

PlaneFilter_Result[]={};
Call PlaneFilter;
Physical Surface("Left") = PlaneFilter_Result[];
AllSurfaces[]-=PlaneFilter_Result[];

PlaneFilter_Result[]={};
PlaneFilter_D=0;
Call PlaneFilter;
Physical Surface("Right") = PlaneFilter_Result[];
AllSurfaces[]-=PlaneFilter_Result[];

PlaneFilter_Result[]={};
PlaneFilter_C=0;
PlaneFilter_B=1;
Call PlaneFilter;
Physical Surface("Bottom") = PlaneFilter_Result[];
AllSurfaces[]-=PlaneFilter_Result[];

PlaneFilter_Result[]={};
PlaneFilter_D=-1;
Call PlaneFilter;
Physical Surface("Top") = PlaneFilter_Result[];
AllSurfaces[]-=PlaneFilter_Result[];

PlaneFilter_Result[]={};
PlaneFilter_D=-1;
PlaneFilter_B=0;
PlaneFilter_A=1;
Call PlaneFilter;
Physical Surface("Front") = PlaneFilter_Result[];
AllSurfaces[]-=PlaneFilter_Result[];

PlaneFilter_Result[]={};
PlaneFilter_D=0;
Call PlaneFilter;
Physical Surface("Back") = PlaneFilter_Result[];
AllSurfaces[]-=PlaneFilter_Result[];

Physical Surface("Inside") = AllSurfaces[];
Physical Volume("Volume") = Vol[0];

Mesh.CharacteristicLengthFactor=0.1;
Mesh 3;
