
Function PlaneFilter
// -----------------------------------------------------------------
//
// Function PlaneFilter
// 'One day free toy'
//
// Created by Andrew Tsiantis
//
// If all the points of a surface belong to 
// the infinite plane with the equation
// 
// PlaneFilter_A*x+PlaneFilter_B*y+PlaneFilter_C*z+PlaneFilter_D=0
//
// within a margin 'PlaneFilter_margin' 
// then the surface is added 
// to the PlaneFilter_Result[] array
//
// -----------------------------------------------------------------

PlaneFilter_margin=0.00001;
PlaneFilter_Surfaces[]= Surface "*";
//PlaneFilter_Result[]={};

For PlaneFilter_jj In {0:#PlaneFilter_Surfaces[]-1}
  PlaneFilter_n[]=PointsOf{Surface{PlaneFilter_Surfaces[PlaneFilter_jj]};};
  PlaneFilter_nn=#PlaneFilter_n[];
  PlaneFilter_cc=0;

  For PlaneFilter_kk In {0:#PlaneFilter_n[]-1}
    PlaneFilter_pn[]=Point{PlaneFilter_n[PlaneFilter_kk]};
	PlaneFilter_px=PlaneFilter_pn[0];
	PlaneFilter_py=PlaneFilter_pn[1];
	PlaneFilter_pz=PlaneFilter_pn[2];
	If ( Abs(PlaneFilter_A*PlaneFilter_px+PlaneFilter_B*PlaneFilter_py+PlaneFilter_C*PlaneFilter_pz+PlaneFilter_D) < PlaneFilter_margin ) 
      PlaneFilter_cc+=1;
    EndIf	
  EndFor
  If (PlaneFilter_cc==PlaneFilter_nn)
    PlaneFilter_Result[]+=PlaneFilter_Surfaces[PlaneFilter_jj];
  EndIf
EndFor
Return
//
// -----------------------------------------------------------------
//








